<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar, QForm } from "quasar";
import { useRouter } from "vue-router";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { checkPermission } from "@/utils/permissions";

import type { QTableProps } from "quasar";
import type { ResponseItems } from "@/modules/06_retirement/interface/response/exitInterview";
import DialogFooter from "@/modules/05_placement/components/PersonalList/DialogFooter.vue";

import DialogHeader from "@/components/DialogHeader.vue";

/** use */
const $q = useQuasar(); //ใช้ noti quasar
const router = useRouter();
const mixin = useCounterMixin();
const myForm = ref<QForm>();
const {
  messageError,
  date2Thai,
  showLoader,
  hideLoader,
  success,
  dialogConfirm,
  onSearchDataTable,
  convertDateToAPI
} = mixin;

/** คอลัมน์ */
const rows = ref<ResponseItems[]>([]);
const rowsData = ref<ResponseItems[]>([]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullname",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "realReason",
    align: "left",
    label: "สาเหตุที่ลาออก",
    sortable: true,
    field: "realReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "notExitFactor",
    align: "left",
    label: "ปัจจัยที่ช่วยเปลี่ยนใจไม่อยากลาออก",
    sortable: true,
    field: "notExitFactor",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "futureWork",
    align: "left",
    label: "อนาคตกลับจะมาร่วมงานหรือไม่",
    sortable: true,
    field: "futureWork",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "futureWorkReason",
    align: "left",
    label: "เหตุผลที่อยากกลับมาร่วมงาน",
    sortable: true,
    field: "futureWorkReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "havejob",
    align: "left",
    label: "มีงานใหม่หรือไม่",
    sortable: true,
    field: "havejob",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "havejobReason",
    align: "left",
    label: "เหตุผลที่มีงานใหม่",
    sortable: true,
    field: "havejobReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "appointDate",
    align: "left",
    label: "วันนัดหมายเพื่อสัมภาษณ์",
    sortable: true,
    field: "appointDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "datetext",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "datetext",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
/** คอลัมน์ที่แสดง */
const visibleColumns = ref<string[]>([]);

/**
 * ตัวแปร
 */
const dateBreak = ref<Date | null>(null);
const daterow = ref<string | null>("");
const id = ref<string>("");
const filters = ref<ResponseItems[]>([]);
const modal = ref<boolean>(false);
const filterKeyword = ref<string>("");
const filterRef = ref<any>(null);

//นำข้อมูลจาก API มาแสดง
async function fecthlist() {
  showLoader();
  await http
    .get(config.API.listExitInterview())
    .then(async (res) => {
      const data = await res.data.result;
      let list: ResponseItems[] = [];
      data.map((r: ResponseItems) => {
        list.push({
          datetext: r.createdAt !== null ? date2Thai(r.createdAt) : "-",
          fullname: r.fullname ?? "",
          createdAt: new Date(r.createdAt),
          futureWork: !!r.futureWork,
          futureWorkReason: r.futureWorkReason ?? "-",
          havejob: !!r.havejob,
          havejobReason: r.havejobReason ?? "-",
          id: r.id ?? "",
          lastUpdatedAt: new Date(r.lastUpdatedAt),
          notExitFactor: r.notExitFactor ?? "-",
          realReason: r.realReason ? r.realReason : "-",
          suggestFriends: !!r.suggestFriends,
          suggestFriendsReason: r.suggestFriendsReason ?? "-",
          suggestion: r.suggestion ?? "-",
          status: r.status ?? "-",
          appointDate: date2Thai(r.appointDate),
        });
      });
      rows.value = list;
      rowsData.value = list;

      filters.value = list;
    })
    .catch((e: any) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

//กําหนดวันนัดหมายเพื่อทําการสัมภาษณ์การลาออก
async function saveAppoint() {
  await myForm.value!.validate().then(async (result: boolean) => {
    if (result) {
      dialogConfirm($q, async () => {
        const body = {
          appointDate: convertDateToAPI(dateBreak.value),
        };
        showLoader();
        await http
          .put(config.API.AppointInterview(id.value), body)
          .then(async () => {
            await fecthlist();
            success($q, "วันนัดหมายเพื่อทําการสัมภาษณ์การลาออกสำเร็จ");
            closeModal();
          })
          .catch((e) => {
            messageError($q, e);
          })
          .finally(async () => {
            hideLoader();
          });
      });
    }
  });
}

/**
 * ฟังก์ชั่น validate DATE ไทย
 * @param thaiDate วันที่ไทย
 */
function validationDate(thaiDate: string | null) {
  if (thaiDate && daterow.value) {
    let a = convertThaiDateToNumeric(thaiDate);
    let b = daterow.value;
    if (a) {
      return a > b;
    }
  }
}

//แปลงเดือนจากตัวเลขเป็นภาษาอ่าน
function convertThaiDateToNumeric(thaiDate: string) {
  const parts = thaiDate.split(" ");
  if (parts.length !== 3) return null;
  const [day, month, year] = parts;
  const monthMap: any = {
    "ม.ค.": "01",
    "ก.พ.": "02",
    "มี.ค.": "03",
    "เม.ย.": "04",
    "พ.ค.": "05",
    "มิ.ย.": "06",
    "ก.ค.": "07",
    "ส.ค.": "08",
    "ก.ย.": "09",
    "ต.ค.": "10",
    "พ.ย.": "11",
    "ธ.ค.": "12",
  };
  if (!(month in monthMap)) return null;
  const numericDate = `${year}${monthMap[month]}${day}`;
  return numericDate;
}
/**
 * modal Setting
 */
const openModal = () => (modal.value = true);
const closeModal = () => (modal.value = false);
function resetFilter() {
  filterKeyword.value = "";
  filterRef.value.focus();
}

function openModalCalendar(rows: any) {
  openModal();
  dateBreak.value = null;
  id.value = rows.id;
  daterow.value = convertThaiDateToNumeric(rows.datetext);
}

function onSearch() {
  rows.value = onSearchDataTable(
    filterKeyword.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

/** HOOK */
onMounted(async () => {
  await fecthlist();
  if (columns.value) {
    visibleColumns.value = columns.value.map((r: any) => r.name);
  }
});
</script>
<template v-slot:body="props">
  <div class="toptitle text-dark col-12 row items-center">
    รายการ Exit interview
  </div>
  <q-card flat bordered class="col-12 q-mt-sm">
    <q-separator />
    <div class="col-12 row q-pa-md">
      <div class="row col-12 q-col-gutter-sm">
        <div class="row col-12">
          <div>
            <q-btn
              v-if="
                checkPermission($route)?.attrIsGet &&
                checkPermission($route)?.attrIsUpdate &&
                checkPermission($route)?.attrOwnership == 'OWNER'
              "
              color="blue-9"
              icon="mdi-square-edit-outline"
              outline
              @click="$router.push('/retirement/exit-interview/edit-question')"
              ><span class="q-pl-sm">แก้ไขคำถาม</span></q-btn
            >
          </div>
          <q-space />
          <div class="row q-col-gutter-sm">
            <q-input
              standout
              dense
              v-model="filterKeyword"
              ref="filterRef"
              outlined
              placeholder="ค้นหา"
              @keydown.enter.prevent="onSearch"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>
            <q-select
              v-model="visibleColumns"
              multiple
              outlined
              dense
              options-dense
              :display-value="$q.lang.table.columns"
              emit-value
              map-options
              :options="columns"
              option-value="name"
              style="min-width: 140px"
            />
          </div>
        </div>

        <div class="col-12">
          <d-table
            :columns="columns"
            :rows="rows"
            row-key="id"
            :visible-columns="visibleColumns"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width />
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <q-btn
                    flat
                    dense
                    round
                    v-if="checkPermission($route)?.attrIsGet"
                    color="info"
                    icon="mdi-eye"
                    @click="
                      router.push(
                        `/retirement/exit-interview/questionnair-detail/${props.row.id}`
                      )
                    "
                  >
                    <q-tooltip>รายละเอียด</q-tooltip>
                  </q-btn>
                  <q-btn
                    v-if="
                      checkPermission($route)?.attrIsGet &&
                      checkPermission($route)?.attrIsUpdate
                    "
                    flat
                    dense
                    round
                    color="edit"
                    icon="edit"
                    @click="
                      router.push(
                        `/retirement/exit-interview/questionnair/${props.row.id}`
                      )
                    "
                  >
                    <q-tooltip>แก้ไขข้อมูล</q-tooltip>
                  </q-btn>

                  <q-btn
                    v-if="
                      checkPermission($route)?.attrIsGet &&
                      checkPermission($route)?.attrIsUpdate
                    "
                    icon="mdi-calendar"
                    :color="!props.row.appointDate ? 'blue-7' : 'grey-5'"
                    :disable="props.row.appointDate !== ''"
                    flat
                    round
                    dense
                    @click="openModalCalendar(props.row)"
                  >
                    <q-tooltip>วันนัดหมายเพื่อทําการสัมภาษณ์การลาออก</q-tooltip>
                  </q-btn>
                </q-td>
                <q-td key="no" :props="props">
                  {{ props.rowIndex + 1 }}
                </q-td>
                <q-td key="fullname" :props="props">
                  {{ props.row.fullname ? props.row.fullname : "-" }}
                </q-td>
                <q-td key="realReason" :props="props">
                  {{ props.row.realReason ? props.row.realReason : "-" }}
                </q-td>
                <q-td key="notExitFactor" :props="props">
                  {{ props.row.notExitFactor ? props.row.notExitFactor : "-" }}
                </q-td>
                <q-td key="futureWork" :props="props">
                  {{ props.row.futureWork ? "ใช่" : "ไม่" }}
                </q-td>
                <q-td key="futureWorkReason" :props="props">
                  {{
                    props.row.futureWorkReason
                      ? props.row.futureWorkReason
                      : "-"
                  }}
                </q-td>
                <q-td key="havejob" :props="props">
                  {{ props.row.havejob ? "ใช่" : "ไม่" }}
                </q-td>

                <q-td key="havejobReason" :props="props">
                  <div class="table_ellipsis">
                    {{
                      props.row.havejobReason ? props.row.havejobReason : "-"
                    }}
                  </div>
                </q-td>
                <q-td key="appointDate" :props="props">
                  {{ props.row.appointDate ? props.row.appointDate : "-" }}
                </q-td>
                <q-td key="datetext" :props="props">
                  {{ props.row.datetext ? props.row.datetext : "-" }}
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </div>
    </div>
  </q-card>

  <!-- dialog กำหนดวันหนัดหมายสัมภาษณ์ -->
  <q-dialog v-model="modal" persistent>
    <q-card style="width: 800px">
      <q-form ref="myForm">
        <DialogHeader
          :tittle="'กําหนดวันนัดหมายเพื่อทําการสัมภาษณ์การลาออก'"
          :close="closeModal"
        />
        <q-separator />
        <q-card-section class="q-p-sm q-gutter-md">
          <div class="col-xs-12 col-sm-12 col-md-12">
            <datepicker
              menu-class-name="modalfix"
              v-model="dateBreak"
              :locale="'th'"
              autoApply
              :enableTimePicker="false"
              week-start="0"
            >
              <template #year="{ year }">{{ year + 543 }}</template>
              <template #year-overlay-value="{ value }">{{
                parseInt(value + 543)
              }}</template>
              <template #trigger>
                <q-input
                  outlined
                  dense
                  class="inputgreen"
                  :model-value="
                    dateBreak !== null ? date2Thai(dateBreak) : null
                  "
                  hide-bottom-space
                  :label="`${' วันนัดหมายเพื่อทําการสัมภาษณ์การลาออก'}`"
                  :rules="[
                    (val:string) => !!val || `${'กรุณาเลือกลงวันที่'}`,
                    (val:string) =>
                      validationDate(val) ||
                      `${'วันที่นัดหมายต้องมากกว่าวันที่สร้าง'}`,
                  ]"
                >
                  <template v-slot:prepend>
                    <q-icon
                      name="event"
                      class="cursor-pointer"
                      style="color: var(--q-primary)"
                    >
                    </q-icon>
                  </template>
                </q-input>
              </template>
            </datepicker>
          </div>
        </q-card-section>
        <q-separator />
        <DialogFooter :editvisible="true" :save="saveAppoint" />
      </q-form>
    </q-card>
  </q-dialog>
</template>
<style scoped lang="scss"></style>
